

// LES FORMES

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

abstract class Forme { 
  PShape s; // le contour de la forme
 
  Forme() { // constructeur
    s=createShape(); // creation de la forme
  }
 
  Forme translation(float x,float y) { s.applyMatrix(1,0,x, 0,1,y); return this; } // translation
  Forme symetrie() { s.applyMatrix(-1,0,9, 0,1,0); return this; } // symetrie
  Forme rotation() { s.applyMatrix(0,-1,9, 1,0,0); return this; } // rotation
  Forme rotation(int n) { for (int i=0; i<n; i++) rotation(); return this; } // rotations

  void dessiner(int c) { // dessin de la forme
    s.setFill(c); // remplissage de la forme avec la couleur c
    shape(s,0,0); // dessin de la forme
  }
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

class FormeDroit extends Forme { 
  FormeDroit() { // constructeur
    s.beginShape();
    s.vertex(0,3); s.vertex(9,3); s.vertex(9,6); s.vertex(0,6);
    s.endShape(CLOSE);
  }
}

//  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //

class FormeArc45 extends Forme { 
  FormeArc45() { // constructeur (petit arc de 45°)     
    s.beginShape();
    s.vertex(0,3); s.quadraticVertex(4,3, 8,-1); s.vertex(10,1); s.quadraticVertex(5,6, 0,6); 
    s.endShape(CLOSE);
  }
}

//  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //

class FormeBiais extends Forme { 
  FormeBiais() { // constructeur
    s.beginShape();
    s.vertex(8,-1); s.vertex(10,1); s.vertex(1,10); s.vertex(-1,8);
    s.endShape(CLOSE);
  } 
}

//  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //

class FormeVide extends Forme { // forme pour la tjs (voie absente)
  FormeVide() {
    s.beginShape();
    s.vertex(0,3); s.vertex(4,3); s.vertex(8,-1); s.vertex(10,1); s.vertex(5,6); s.vertex(0,6); 
    s.endShape(CLOSE);
  }
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////